Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/src/Parameters_print.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/src/Parameters_print.cpp	(revision 74)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/src/Parameters_print.cpp	(revision 75)
@@ -8,5 +8,4 @@
 #include "Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/include/Parameters.h"
 #include "Behavioural/include/XML.h"
-using namespace std;
 
 namespace morpheo                    {
@@ -20,5 +19,5 @@
 #undef  FUNCTION
 #define FUNCTION "Register_unit::print"
-  string Parameters::print (uint32_t depth)
+  std::string Parameters::print (uint32_t depth)
   {
     log_printf(FUNC,Register_unit,FUNCTION,"Begin");
@@ -73,6 +72,6 @@
 #undef  FUNCTION
 #define FUNCTION "Register_unit::operator<<"
-  ostream& operator<< (ostream& output_stream ,
-		       morpheo::behavioural::core::multi_execute_loop::execute_loop::register_unit::Parameters & x)
+  std::ostream& operator<< (std::ostream& output_stream ,
+			    morpheo::behavioural::core::multi_execute_loop::execute_loop::register_unit::Parameters & x)
   {
     log_printf(FUNC,Register_unit,FUNCTION,"Begin");
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/src/Register_unit.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/src/Register_unit.cpp	(revision 74)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/src/Register_unit.cpp	(revision 75)
@@ -34,12 +34,13 @@
     ,_param            (param)
     ,_usage            (usage)
-#ifdef STATISTICS
-    ,_param_statistics (param_statistics)
-#endif
   {
     log_printf(FUNC,Register_unit,FUNCTION,"Begin");
 
     log_printf(INFO,Register_unit,FUNCTION,"Allocation");
-    allocation ();
+    allocation (
+#ifdef STATISTICS
+		param_statistics
+#endif
+		);
 
 #ifdef STATISTICS
@@ -47,7 +48,5 @@
 
     // Allocation of statistics
-    _stat = new Statistics (static_cast<string>(_name),
-			    param_statistics          ,
-			    param);
+    statistics_declaration(param_statistics);
 #endif
 
@@ -84,6 +83,4 @@
 #ifdef STATISTICS
     log_printf(INFO,Register_unit,FUNCTION,"Generate Statistics file");
-
-    _stat->generate_file(statistics(0));
     delete _stat;
 #endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/src/Register_unit_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/src/Register_unit_allocation.cpp	(revision 74)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/src/Register_unit_allocation.cpp	(revision 75)
@@ -19,8 +19,12 @@
 #undef  FUNCTION
 #define FUNCTION "Register_unit::allocation"
-  void Register_unit::allocation (void)
+  void Register_unit::allocation (
+#ifdef STATISTICS
+				  morpheo::behavioural::Parameters_Statistics * param_statistics
+#else
+				  void
+#endif
+				  )
   {
-    string rename, name_component;
-
     log_printf(FUNC,Register_unit,FUNCTION,"Begin");
 
@@ -249,5 +253,5 @@
     // ~~~~~[ Component ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
 
-    string name;
+    std::string name;
      
     component_gpr        = new morpheo::behavioural::generic::registerfile::RegisterFile::RegisterFile * [_param->_nb_ooo_engine];
@@ -263,5 +267,5 @@
 	  (name.c_str()
 #ifdef STATISTICS
-	   ,_param_statistics
+	   ,param_statistics
 #endif
 	   ,_param->_param_gpr [i]
@@ -283,5 +287,5 @@
 	  (name.c_str()
 #ifdef STATISTICS
-	   ,_param_statistics
+	   ,param_statistics
 #endif
 	   ,_param->_param_gpr_status [i]
@@ -303,5 +307,5 @@
 	  (name.c_str()
 #ifdef STATISTICS
-	   ,_param_statistics
+	   ,param_statistics
 #endif
 	   ,_param->_param_spr [i]
@@ -322,5 +326,5 @@
 	  (name.c_str()
 #ifdef STATISTICS
-	   ,_param_statistics
+	   ,param_statistics
 #endif
 	   ,_param->_param_spr_status [i]
@@ -343,5 +347,5 @@
       (name.c_str()
 #ifdef STATISTICS
-       ,_param_statistics
+       ,param_statistics
 #endif
        ,_param->_param_glue
@@ -358,10 +362,11 @@
      
     // ~~~~~[ Instanciation ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
-
+    std::string name_component;
+    
     for (uint32_t i=0; i<_param->_nb_ooo_engine; i++)
       {
 	name_component = _name+"_gpr_"+toString(i);
 	
-	cout << "Instance : " << name_component << endl;
+	std::cout << "Instance : " << name_component << std::endl;
 	
 #ifdef POSITION
@@ -420,5 +425,5 @@
 	  name_component = _name+"_gpr_status_"+toString(i);
 	  
-	  cout << "Instance : " << name_component << endl;
+	  std::cout << "Instance : " << name_component << std::endl;
 	  
 #ifdef POSITION
@@ -544,5 +549,5 @@
 	name_component = _name+"_spr_"+toString(i);
 	
-	cout << "Instance : " << name_component << endl;
+	std::cout << "Instance : " << name_component << std::endl;
 	
 #ifdef POSITION
@@ -601,5 +606,5 @@
 	  name_component = _name+"_spr_status_"+toString(i);
 	  
-	  cout << "Instance : " << name_component << endl;
+	  std::cout << "Instance : " << name_component << std::endl;
 	  
 #ifdef POSITION
@@ -724,5 +729,5 @@
       name_component = _name+"_glue";
      
-      cout << "Instance : " << name_component << endl;
+      std::cout << "Instance : " << name_component << std::endl;
      
 #ifdef POSITION
@@ -1034,5 +1039,5 @@
 #endif
 
-//     cout << *_component << endl;
+//     std::cout << *_component << std::endl;
 
     log_printf(FUNC,Register_unit,FUNCTION,"End");
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/src/Register_unit_end_cycle.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/src/Register_unit_end_cycle.cpp	(revision 75)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/src/Register_unit_end_cycle.cpp	(revision 75)
@@ -0,0 +1,44 @@
+#if defined(STATISTICS) or defined(VHDL_TESTBENCH)
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/include/Register_unit.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_execute_loop {
+namespace execute_loop {
+namespace register_unit {
+
+#undef  FUNCTION
+#define FUNCTION "Register_unit::end_cycle"
+void Register_unit::end_cycle ()
+  {
+    log_printf(FUNC,Register_unit,FUNCTION,"Begin");
+
+#ifdef STATISTICS
+    _stat->end_cycle();
+#endif    
+
+#ifdef VHDL_TESTBENCH
+    // Evaluation before read the ouput signal
+//  sc_start(0);
+    _interfaces->testbench();
+#endif
+
+    log_printf(FUNC,Register_unit,FUNCTION,"End");
+  };
+
+}; // end namespace register_unit
+}; // end namespace execute_loop
+}; // end namespace multi_execute_loop
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/src/Register_unit_statistics_declaration.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/src/Register_unit_statistics_declaration.cpp	(revision 75)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/src/Register_unit_statistics_declaration.cpp	(revision 75)
@@ -0,0 +1,47 @@
+#ifdef STATISTICS
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/include/Register_unit.h"
+
+namespace morpheo {
+namespace behavioural {
+namespace core {
+namespace multi_execute_loop {
+namespace execute_loop {
+namespace register_unit {
+
+#undef  FUNCTION
+#define FUNCTION "Register_unit::statistics_declaration"
+  void Register_unit::statistics_declaration (morpheo::behavioural::Parameters_Statistics * param_statistics)
+  {
+    log_printf(FUNC,Register_unit,FUNCTION,"Begin");
+
+    _stat = new Stat (static_cast<std::string>(_name),
+		      "Register_unit",
+		      param_statistics);
+
+    for (uint32_t i=0; i<_param->_nb_ooo_engine; i++)
+      {
+	_stat->add_stat(component_gpr       [i]->_stat);
+	_stat->add_stat(component_gpr_status[i]->_stat);
+	_stat->add_stat(component_spr       [i]->_stat);
+	_stat->add_stat(component_spr_status[i]->_stat);
+      }
+    _stat->add_stat(component_glue->_stat);
+
+    log_printf(FUNC,Register_unit,FUNCTION,"End");
+  };
+
+}; // end namespace register_unit
+}; // end namespace execute_loop
+}; // end namespace multi_execute_loop
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/src/Register_unit_transition.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/src/Register_unit_transition.cpp	(revision 74)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/src/Register_unit_transition.cpp	(revision 75)
@@ -24,10 +24,6 @@
     log_printf(FUNC,Register_unit,FUNCTION,"Begin");
 
-#ifdef STATISTICS
-    _stat->add();
-#endif    
-
-#ifdef VHDL_TESTBENCH
-    vhdl_testbench_transition ();
+#if defined(STATISTICS) or defined(VHDL_TESTBENCH)
+    end_cycle();
 #endif
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/include/Counter.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/include/Counter.h	(revision 74)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/include/Counter.h	(revision 75)
@@ -27,6 +27,4 @@
 #include "Behavioural/include/Component.h"
 
-using namespace std;
-
 namespace morpheo {
 namespace behavioural {
@@ -41,10 +39,10 @@
     // -----[ fields ]----------------------------------------------------
     // Parameters
-  protected : const string     _name;
+  protected : const std::string     _name;
 
   protected : const Parameters _param;
 
 #ifdef STATISTICS
-  private   : Stat                           * _stat;
+  public    : Stat                           * _stat;
 #endif
 
@@ -75,5 +73,5 @@
   public  :          Counter              (sc_module_name                              name,
 #else					       
-  public  :          Counter              (string                                      name,
+  public  :          Counter              (std::string                                 name,
 #endif					       
 #ifdef STATISTICS
@@ -96,5 +94,4 @@
 #ifdef STATISTICS
   public  : void     statistics_declaration    (morpheo::behavioural::Parameters_Statistics * param_statistics);
-  public  : string   statistics_print          (uint32_t depth);
 #endif
 					       
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/include/Parameters.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/include/Parameters.h	(revision 74)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/include/Parameters.h	(revision 75)
@@ -32,9 +32,8 @@
   public : ~Parameters () ;
 
-  public : string msg_error (void);
-
-  public :        string   print      (uint32_t depth);
-  public : friend ostream& operator<< (ostream& output_stream,
-				       morpheo::behavioural::generic::counter::Parameters & x);
+  public :        std::string   msg_error  (void);
+  public :        std::string   print      (uint32_t depth);
+  public : friend std::ostream& operator<< (std::ostream& output_stream,
+					    morpheo::behavioural::generic::counter::Parameters & x);
   };
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Counter_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Counter_allocation.cpp	(revision 74)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Counter_allocation.cpp	(revision 75)
@@ -17,6 +17,4 @@
   void Counter::allocation (void)
   {
-    string rename;
-
     log_printf(FUNC,Counter,"allocation","Begin");
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Counter_statistics_declaration.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Counter_statistics_declaration.cpp	(revision 74)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Counter_statistics_declaration.cpp	(revision 75)
@@ -20,5 +20,5 @@
     log_printf(FUNC,Counter,FUNCTION,"Begin");
 
-    _stat = new Stat (static_cast<string>(_name),
+    _stat = new Stat (static_cast<std::string>(_name),
 		      "Counter",
 		      param_statistics);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Counter_vhdl_body.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Counter_vhdl_body.cpp	(revision 74)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Counter_vhdl_body.cpp	(revision 75)
@@ -21,5 +21,5 @@
     for (uint32_t i=0; i<_param._nb_port; i++)
       {
-	string counter_inc, counter_dec;
+	std::string counter_inc, counter_dec;
 
 	if (_param._size_data > 1)
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Parameters_msg_error.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Parameters_msg_error.cpp	(revision 74)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Parameters_msg_error.cpp	(revision 75)
@@ -9,5 +9,4 @@
 #include "Behavioural/Generic/Counter/include/Types.h"
 #include <sstream>
-using namespace std;
 
 namespace morpheo                    {
@@ -17,9 +16,9 @@
 
 
-  string Parameters::msg_error(void)
+  std::string Parameters::msg_error(void)
   {
     log_printf(FUNC,Counter,"msg_error","Begin");
 
-    string msg = "";
+    std::string msg = "";
 
     if (_size_data < 1)
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Parameters_print.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Parameters_print.cpp	(revision 74)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Parameters_print.cpp	(revision 75)
@@ -8,5 +8,4 @@
 #include "Behavioural/Generic/Counter/include/Parameters.h"
 #include "Behavioural/include/XML.h"
-using namespace std;
 
 namespace morpheo                    {
@@ -16,5 +15,5 @@
 
 
-  string Parameters::print (uint32_t depth)
+  std::string Parameters::print (uint32_t depth)
   {
     log_printf(FUNC,Counter,"print","Begin");
@@ -36,6 +35,6 @@
   };
 
-  ostream& operator<< (ostream& output_stream ,
-		       morpheo::behavioural::generic::counter::Parameters & x)
+  std::ostream& operator<< (std::ostream& output_stream ,
+			    morpheo::behavioural::generic::counter::Parameters & x)
   {
     output_stream << x.print(0);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/include/Parameters.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/include/Parameters.h	(revision 74)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/include/Parameters.h	(revision 75)
@@ -32,9 +32,9 @@
   public : ~Parameters () ;
 
-  public : string msg_error (void);
+  public :        std::string   msg_error  (void);
 
-  public :        string   print      (uint32_t depth);
-  public : friend ostream& operator<< (ostream& output_stream,
-				       morpheo::behavioural::generic::queue::Parameters & x);
+  public :        std::string   print      (uint32_t depth);
+  public : friend std::ostream& operator<< (std::ostream& output_stream,
+					    morpheo::behavioural::generic::queue::Parameters & x);
   };
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/include/Queue.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/include/Queue.h	(revision 74)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/include/Queue.h	(revision 75)
@@ -22,5 +22,5 @@
 #include "Behavioural/Generic/Queue/include/Parameters.h"
 #ifdef STATISTICS
-#include "Behavioural/Generic/Queue/include/Statistics.h"
+#include "Behavioural/include/Stat.h"
 #endif
 #include "Behavioural/include/Component.h"
@@ -29,7 +29,4 @@
 #endif
 #include "Behavioural/include/Usage.h"
-
-using namespace std;
-using namespace morpheo::behavioural::generic::queue_control;
 
 namespace morpheo {
@@ -46,5 +43,5 @@
     // -----[ fields ]----------------------------------------------------
     // Parameters
-  protected : const string       _name;
+  protected : const std::string       _name;
   protected : const Parameters * _param;
   private   : const Tusage_t     _usage;
@@ -55,5 +52,5 @@
 
 #ifdef STATISTICS
-  private   : Statistics                     * _stat;
+  public    : Stat                           * _stat;
 #endif
 
@@ -99,5 +96,5 @@
    sc_module_name                                name,
 #else					       
-   string                                        name,
+   std::string                                   name,
 #endif					       
 #ifdef STATISTICS
@@ -116,6 +113,7 @@
   public  : void     genMoore                  (void);
 #endif					       
+
 #ifdef STATISTICS
-  public  : string   statistics                (uint32_t depth);
+  public  : void     statistics_declaration    (morpheo::behavioural::Parameters_Statistics * param_statistics);
 #endif
 					       
@@ -125,7 +123,7 @@
   private : void     vhdl_body                 (Vhdl * & vhdl);
 #endif					       
-					       
-#ifdef VHDL_TESTBENCH			       
-  private : void     vhdl_testbench_transition (void);
+
+#if defined(STATISTICS) or defined(VHDL_TESTBENCH)
+  private : void     end_cycle                 (void);
 #endif
   };
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/src/Parameters_msg_error.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/src/Parameters_msg_error.cpp	(revision 74)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/src/Parameters_msg_error.cpp	(revision 75)
@@ -9,6 +9,4 @@
 #include "Behavioural/Generic/Queue/include/Parameters.h"
 #include <sstream>
-using namespace std;
-
 namespace morpheo                    {
 namespace behavioural {
@@ -19,9 +17,9 @@
 #undef  FUNCTION
 #define FUNCTION "Queue::msg_error"
-  string Parameters::msg_error(void)
+  std::string Parameters::msg_error(void)
   {
     log_printf(FUNC,Queue,FUNCTION,"Begin");
 
-    string msg = "";
+    std::string msg = "";
 
     return msg;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/src/Parameters_print.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/src/Parameters_print.cpp	(revision 74)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/src/Parameters_print.cpp	(revision 75)
@@ -8,5 +8,4 @@
 #include "Behavioural/Generic/Queue/include/Parameters.h"
 #include "Behavioural/include/XML.h"
-using namespace std;
 
 namespace morpheo                    {
@@ -18,5 +17,5 @@
 #undef  FUNCTION
 #define FUNCTION "Queue::print"
-  string Parameters::print (uint32_t depth)
+  std::string Parameters::print (uint32_t depth)
   {
     log_printf(FUNC,Queue,FUNCTION,"Begin");
@@ -36,6 +35,6 @@
 #undef  FUNCTION
 #define FUNCTION "Queue::operator<<"
-  ostream& operator<< (ostream& output_stream ,
-		       morpheo::behavioural::generic::queue::Parameters & x)
+  std::ostream& operator<< (std::ostream& output_stream ,
+			    morpheo::behavioural::generic::queue::Parameters & x)
   {
     log_printf(FUNC,Queue,FUNCTION,"Begin");
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/src/Queue.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/src/Queue.cpp	(revision 74)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/src/Queue.cpp	(revision 75)
@@ -32,7 +32,4 @@
     ,_param            (param)
     ,_usage            (usage)
-// #ifdef STATISTICS
-// 			      ,_param_statistics (param_statistics)
-// #endif
   {
     log_printf(FUNC,Queue,FUNCTION,"Begin");
@@ -46,8 +43,5 @@
 	log_printf(INFO,Queue,FUNCTION,"Allocation of statistics");
 	
-	// Allocation of statistics
-	_stat = new Statistics (static_cast<string>(_name),
-				param_statistics          ,
-				param);
+	statistics_declaration(param_statistics);
       }
 #endif
@@ -102,5 +96,4 @@
 	log_printf(INFO,Queue,FUNCTION,"Generate Statistics file");
 	
-	_stat->generate_file(statistics(0));
 	delete _stat;
       }
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/src/Queue_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/src/Queue_allocation.cpp	(revision 74)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/src/Queue_allocation.cpp	(revision 75)
@@ -19,6 +19,4 @@
   void Queue::allocation (void)
   {
-    string rename;
-
     log_printf(FUNC,Queue,FUNCTION,"Begin");
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/src/Queue_end_cycle.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/src/Queue_end_cycle.cpp	(revision 75)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/src/Queue_end_cycle.cpp	(revision 75)
@@ -0,0 +1,40 @@
+#if defined(STATISTICS) or defined(VHDL_TESTBENCH)
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Generic/Queue/include/Queue.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace generic {
+namespace queue {
+
+#undef  FUNCTION
+#define FUNCTION "Queue::end_cycle"
+  void Queue::end_cycle ()
+  {
+    log_printf(FUNC,Queue,FUNCTION,"Begin");
+
+#ifdef STATISTICS
+    _stat->end_cycle();
+#endif    
+
+#ifdef VHDL_TESTBENCH
+    // Evaluation before read the ouput signal
+//  sc_start(0);
+    _interfaces->testbench();
+#endif
+
+    log_printf(FUNC,Queue,FUNCTION,"End");
+  };
+
+}; // end namespace queue
+}; // end namespace generic
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/src/Queue_statistics_declaration.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/src/Queue_statistics_declaration.cpp	(revision 75)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/src/Queue_statistics_declaration.cpp	(revision 75)
@@ -0,0 +1,34 @@
+#ifdef STATISTICS
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Generic/Queue/include/Queue.h"
+
+namespace morpheo {
+namespace behavioural {
+namespace generic {
+namespace queue {
+
+#undef  FUNCTION
+#define FUNCTION "Queue::statistics_declaration"
+  void Queue::statistics_declaration (morpheo::behavioural::Parameters_Statistics * param_statistics)
+  {
+    log_printf(FUNC,Queue,FUNCTION,"Begin");
+
+    _stat = new Stat (static_cast<std::string>(_name),
+                      "Queue",
+                      param_statistics);
+    
+    log_printf(FUNC,Queue,FUNCTION,"End");
+  };
+
+}; // end namespace queue
+}; // end namespace generic
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/src/Queue_transition.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/src/Queue_transition.cpp	(revision 74)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/src/Queue_transition.cpp	(revision 75)
@@ -53,10 +53,6 @@
       }
 
-#ifdef STATISTICS
-    _stat->add();
-#endif    
-
-#ifdef VHDL_TESTBENCH
-    vhdl_testbench_transition ();
+#if defined(STATISTICS) or defined(VHDL_TESTBENCH)
+    end_cycle ();
 #endif
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue_Control/include/Queue_Control.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue_Control/include/Queue_Control.h	(revision 74)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue_Control/include/Queue_Control.h	(revision 75)
@@ -16,6 +16,4 @@
 #include "Common/include/Debug.h"
 
-using namespace std;
-
 namespace morpheo {
 namespace behavioural {
@@ -27,5 +25,5 @@
   private : const uint32_t     _nb_elt_max;
   private : uint32_t           _nb_elt;
-  private : vector<uint32_t> * _tab;
+  private : std::vector<uint32_t> * _tab;
     
   public  :          Queue_Control  (uint32_t nb_elt_max);
@@ -45,5 +43,5 @@
     
   public : uint32_t operator[] (uint32_t);
-  public : ostream& operator<< (ostream& output_stream);
+  public : std::ostream& operator<< (std::ostream& output_stream);
   };
   
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue_Control/src/Queue_Control.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue_Control/src/Queue_Control.cpp	(revision 74)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue_Control/src/Queue_Control.cpp	(revision 75)
@@ -13,5 +13,5 @@
     log_printf(FUNC,Queue_Control,FUNCTION,"Begin");
 	
-    _tab = new vector<uint32_t>;
+    _tab = new std::vector<uint32_t>;
 
     log_printf(FUNC,Queue_Control,FUNCTION,"End");
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue_Control/src/Queue_Control_operator.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue_Control/src/Queue_Control_operator.cpp	(revision 74)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue_Control/src/Queue_Control_operator.cpp	(revision 75)
@@ -8,5 +8,5 @@
 #undef  FUNCTION
 #define FUNCTION "Queue_Control::operator<<"
-  ostream& Queue_Control::operator<< (ostream& output_stream)
+  std::ostream& Queue_Control::operator<< (std::ostream& output_stream)
   {
     log_printf(FUNC,Queue_Control,FUNCTION,"Begin");
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/include/Parameters.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/include/Parameters.h	(revision 74)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/include/Parameters.h	(revision 75)
@@ -37,9 +37,8 @@
   public : ~Parameters () ;
 
-  public : string msg_error (void);
-
-  public :        string   print      (uint32_t depth);
-  public : friend ostream& operator<< (ostream& output_stream,
-				       morpheo::behavioural::generic::registerfile::registerfile_monolithic::Parameters & x);
+  public :        std::string   msg_error  (void);
+  public :        std::string   print      (uint32_t depth);
+  public : friend std::ostream& operator<< (std::ostream& output_stream,
+					    morpheo::behavioural::generic::registerfile::registerfile_monolithic::Parameters & x);
   };
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/include/RegisterFile_Monolithic.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/include/RegisterFile_Monolithic.h	(revision 74)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/include/RegisterFile_Monolithic.h	(revision 75)
@@ -16,5 +16,4 @@
 #include "Common/include/ToString.h"
 #include <iostream>
-using namespace std;
 
 #include "Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/include/Parameters.h"
@@ -28,6 +27,4 @@
 #endif
 #include "Behavioural/include/Usage.h"
-
-using namespace std;
 
 namespace morpheo                    {
@@ -46,10 +43,10 @@
     // -----[ fields ]----------------------------------------------------
     // Parameters
-  protected : const string       _name;
+  protected : const std::string       _name;
   protected : const Parameters * _param;
   private   : const Tusage_t     _usage;
 
 #ifdef STATISTICS
-  private   : Stat                           * _stat;
+  public    : Stat                           * _stat;
     
   private   : counter_t                      * _stat_nb_read;
@@ -106,5 +103,5 @@
    sc_module_name                              name
 #else					       
-   string                                      name
+   std::string                                      name
 #endif					       
 #ifdef STATISTICS
@@ -128,5 +125,4 @@
 #ifdef STATISTICS
   public  : void     statistics_declaration    (morpheo::behavioural::Parameters_Statistics * param_statistics);
-  public  : string   statistics_print          (uint32_t depth);
 #endif					       
 
@@ -137,6 +133,7 @@
 #endif					       
 					       
+#if defined(STATISTICS) or defined(VHDL_TESTBENCH)
   private : void     end_cycle                 (void);
-
+#endif
   };
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/src/Parameters_msg_error.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/src/Parameters_msg_error.cpp	(revision 74)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/src/Parameters_msg_error.cpp	(revision 75)
@@ -10,5 +10,4 @@
 #include "Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/include/Types.h"
 #include <sstream>
-using namespace std;
 
 namespace morpheo                    {
@@ -18,7 +17,7 @@
 namespace registerfile_monolithic    {
 
-  string Parameters::msg_error(void)
+  std::string Parameters::msg_error(void)
   {
-    string msg = "";
+    std::string msg = "";
 
     if ((8*sizeof(Tdata_t)) < _size_word)
